defmodule DecentralisedBookIndex.Sync.AuthorAliasRegistrySync do
  alias DecentralisedBookIndex.Metadata
  alias DecentralisedBookIndex.Metadata.AuthorAliasRegistry

  def create_update(attrs, server_id) do
    case Metadata.get_author_alias_registry_by_id(attrs.id) do
      {:ok, alias_registry} ->
        attrs =
          attrs
          |> Map.delete(:id)
          |> Map.put(:dbi_server_id, server_id)

        alias_registry
        |> Ash.Changeset.for_update(:sync, attrs)
        |> Ash.update!(authorize?: false)

        :ok

      {:error, %Ash.Error.Query.NotFound{}} ->
        attrs =
          attrs
          |> Map.put(:dbi_server_id, server_id)

        AuthorAliasRegistry
        |> Ash.Changeset.for_create(:sync_create, attrs)
        |> Ash.create!(authorize?: false)

        :ok
    end
  end
end
