defmodule DecentralisedBookIndex.SyncWorker do
  use Oban.Worker,
    queue: :default,
    max_attempts: 2,
    tags: ["sync", "cron"]

  require Logger

  alias DecentralisedBookIndex.SyncTasks.SyncServerTask

  @impl Oban.Worker
  def perform(%Oban.Job{args: args} = job) do
    Logger.info("The cron job (#{job.id}) run SyncServerTask at #{DateTime.utc_now()} with args: #{inspect(args)}.")

    result = SyncServerTask.sync_all()

    Logger.info("The cron job (#{job.id}) is done.")

    result
  end
end
