defmodule DecentralisedBookIndex.SyncTasks.SyncPublishersTaskTest do
  use DecentralisedBookIndex.DataCase

  alias DecentralisedBookIndex.SyncTasks.SyncPublishersTask
  alias DecentralisedBookIndex.Metadata

  alias DecentralisedBookIndex.TestEndpoints
  @test_server_endpoint TestEndpoints.test_api_endpoint()

  setup do
    user = generate(user(role: :moderator))
    %{user: user}
  end

  describe "sync publishers tasks" do
    test "sync publisher", %{user: user} do
      server = generate(dbi_server(url: @test_server_endpoint))

      {:ok, _publisher} = Metadata.create_publisher("Publisher", actor: user)
      {:ok, _publisher} = Metadata.create_publisher("Publisher2", actor: user)

      assert ^server = SyncPublishersTask.sync(server)
    end
  end
end
